pinAM = 6
pinDS = 3
pinLED = 8
sda = 1 -- SDA Pin
scl = 2 -- SCL Pin
gpio.mode(pinLED,gpio.OUTPUT) 
gpio.write(pinLED,gpio.LOW)

am2320.init(sda, scl) --инициализация датчика AM2320

Broker="192.168.0.106" --адрес Вашего брокера !!!
port=1883
myClient="WS1"
login=""
pass=""

--------Функция нициализации дисплея------------
function init_OLED(sda,scl) --Set up the u8glib lib
     sla = 0x3C
     i2c.setup(0, sda, scl, i2c.SLOW)
     disp = u8g.ssd1306_128x32_i2c(sla,1)
     disp:setFont(u8g.font_10x20)
     disp:setFontRefHeightExtendedText()
     disp:setDefaultForegroundColor()
     disp:setFontPosTop()
     --disp:setRot180()     -- Rotate Display if needed
end
--------Функция вывода данных на экран дисплея--------
function print_OLED()
   disp:firstPage()
   repeat   
     disp:drawStr(5, 2, str1)
     disp:drawStr(5, 17, str2)    
   until disp:nextPage() == false   
end

-------Проверка подключения к серверу MQTT------------
m = mqtt.Client( myClient, 120, login, pass)
m:lwt("/pogoda/sensors/", "By!", 0, 0)
m:on("offline", function(con)
  print ("Mqtt Reconnecting.")
  tmr.stop(2)
  tmr.alarm(1, 60000, 1, function()
  print ("Try Reconnecting...")
  m:connect(Broker, port, 0, function(conn)
  print("Mqtt Connected to "..Broker)
  tmr.stop(1)
  tmr.start(2)
  end)
 end)
end)

----- Функция тправки данных на народный мониторинг----
function sendNarod(t2320, h2320, tAM, humiAM, tDS)
            local bat = (adc.readvdd33(0)/1000)
            local dataN = "#18-FE-35-D6-3C-1A\n" -- поставить свои цифры
            dataN =dataN.."#T1#"..tDS.."\n"
            dataN =dataN.."#T2#"..tAM.."\n"
            dataN =dataN.."#T3#"..t2320.."\n"
            dataN =dataN.."#H1#"..humiAM.."\n"
            dataN =dataN.."#H2#"..h2320.."\n"
            dataN =dataN.."#U1#"..bat.."\n"
            dataN = dataN.."##\n"
            print(dataN) 
            conn=net.createConnection(net.TCP, 0)
            conn:on("connection",function(conn, payload)
                conn:send(dataN)
                end)
             conn:on("receive", function(conn, payload)
               print('\nRetrieved in '..((tmr.now()-t)/1000)..' milliseconds.')
               print('Narodmon says '..payload)
               conn:close()               
               end)
             t = tmr.now()
             conn:connect(8283,'narodmon.ru')
        end  

---------Основная функция программы-------
function RunMyProg()
 print("Main  program starts!")  
 tmr.alarm(2, 5000, 1, function() --Публикуем данные каждые 5 сек 
 gpio.write(pinLED,gpio.HIGH)
 publish_data()
 ---------
 init_OLED(1,2) -- подключаем дисплей
 print_OLED()   -- выводим данные на дисплей
 end)
 ---------Передача данных на narodmon.ru-----
 tmr.alarm(4, 360000, 1, function()
 sendNarod(t2320, h2320, tAM, humiAM, tDS)
 end)
 end 

------Получение данных от датчиков--------
function getSensor() 
tmr.alarm(3, 1000, 1, function()
status,tAM,humiAM = dht.readxx(pinAM)
local ds18b20 = require('ds18b20')
  ds18b20.setup(pinDS)
  local addres={}
  addres=ds18b20.addrs()
  tDS = ds18b20.read(addres[1]) 
  rh, t = am2320.read()
  t2320 = t/10
  h2320 = rh/10
  str1=(string.format("t:  %s C", t2320)) --переводим числовые параметры в строковые
  str2=(string.format("Hum:%s%%", h2320))
  
  return str1, str2, t2320, h2320, tAM, humiAM, tDS --возвращаем данные в глобальные переменные
end)
--print(string.format("RH: %s%%", rh / 10))
--print(string.format("Temperature: %s degrees C", t / 10))
end

--------Публикация данных на сервер MQTT-----
function publish_data()
            m:publish("/pogoda/sensors/tempDS",tDS,0,0, function(conn)       end)
           -- print("TempDS "..tDS.." published!")
              m:publish("/pogoda/sensors/tempAM",tAM,0,0, function(conn)     end)
         --   print("TempAM "..tAM.." published!")
             m:publish("/pogoda/sensors/humiAM",humiAM,0,0, function(conn)   end) 
         --   print("HumiAM "..humiAM.." published!")
             m:publish("/pogoda/sensors/t2320",t2320,0,0, function(conn)   end) 
        --    print("t2320 "..t2320.." published!")
             m:publish("/pogoda/sensors/h2320",h2320,0,0, function(conn)   end) 
         --   print("h2320 "..h2320.." published!")
            local bat = (adc.readvdd33(0)/1000)
             m:publish("/pogoda/sensors/volt/state",bat,0,0, function(conn)   end)
         --   print("Bat "..bat.." published!")
              print("MQTT published!")
             collectgarbage() 
           gpio.write(pinLED,gpio.LOW)
           end                               

 ---START----  
     
 getSensor()

 tmr.alarm(0, 3000, 1, function() -- проверяем WiFi каждые 3 сек
  if wifi.sta.status() == 5 and wifi.sta.getip() ~= nil then
  tmr.stop(0) 
  m:connect(Broker, port, 0, function(conn)
  print("Mqtt Connected to: " .. Broker)
  RunMyProg()
  end)
  end
end)


